#include "include/Simulation.hpp"

struct Config
{
    int scenario;
    std::vector<PoseSE2> ASVs_eta0;
    std::vector<Eigen::Vector2d> ASVs_goal;
    std::vector<double> ASVs_nominal_speed;
    std::vector<bool> activate_COLAV{true, true, true, true, true};
    std::vector<bool> plot_opt{true, false, false};
};

int main()
{   
    std::vector<Config> cfgs;
    std::vector<Eigen::Vector2d> empty_map;

    Config cfg1;
    cfg1.scenario = 1;
    cfg1.ASVs_eta0 = {coord(80,180).first, coord(80,0).first};
    cfg1.ASVs_goal = {coord(90,180).second, coord(90,0).second};
    cfg1.ASVs_nominal_speed = {2.5, 2.5};
    cfgs.push_back(cfg1);

    Config cfg2;
    cfg2.scenario = 2;
    cfg2.ASVs_eta0 = {coord(80,180).first, coord(80,90).first};
    cfg2.ASVs_goal = {coord(90,180).second, coord(90,90).second};
    cfg2.ASVs_nominal_speed = {2.5, 2.5};
    cfgs.push_back(cfg2);

    Config cfg3;
    cfg3.scenario = 3;
    cfg3.ASVs_eta0 = {coord(80,180).first, coord(45,180).first};
    cfg3.ASVs_goal = {coord(90,180).second, coord(40,180).second};
    cfg3.ASVs_nominal_speed = {2.5, 1};
    cfg3.activate_COLAV[1] = false;
    cfgs.push_back(cfg3);

    Config cfg4;
    cfg4.scenario = 4;
    cfg4.ASVs_eta0 = {coord(80,180).first, coord(80,-135).first};
    cfg4.ASVs_goal = {coord(90,180).second, coord(90,-135).second};
    cfg4.ASVs_nominal_speed = {2.5, 2.5};
    cfgs.push_back(cfg4);

    Config cfg5;
    cfg5.scenario = 5;
    cfg5.ASVs_eta0 = {coord(80,180).first, coord(80,0).first, coord(80,90).first};
    cfg5.ASVs_goal = {coord(90,180).second, coord(90,0).second, coord(90,90).second};
    cfg5.ASVs_nominal_speed = {2.5, 2.5, 2.5};
    cfgs.push_back(cfg5);

    Config cfg6;
    cfg6.scenario = 6;
    cfg6.ASVs_eta0 = {coord(80,180).first, coord(80,170).first, coord(80,135).first};
    cfg6.ASVs_goal = {coord(80,180).second, coord(80,170).second, coord(80,135).second};
    cfg6.ASVs_nominal_speed = {2.5, 2.5, 2.5};
    cfgs.push_back(cfg6);

    Config cfg7;
    cfg7.scenario = 7;
    cfg7.ASVs_eta0 = {coord(80,180).first, coord(45,180).first, coord(80,135).first};
    cfg7.ASVs_goal = {coord(90,180).second, coord(45,180).second, coord(90,135).second};
    cfg7.ASVs_nominal_speed = {2.5, 1, 2.5};
    cfg7.activate_COLAV[1] = false;
    cfgs.push_back(cfg7);

    Config cfg8;
    cfg8.scenario = 8;
    cfg8.ASVs_eta0 = {coord(80,180).first, coord(80,0).first, coord(80,90).first};
    cfg8.ASVs_goal = {coord(90,180).second, coord(90,0).second, coord(90,90).second};
    cfg8.ASVs_nominal_speed = {2, 2, 2};
    cfgs.push_back(cfg8);

    Config cfg9;
    cfg9.scenario = 9;
    cfg9.ASVs_eta0 = {coord(80,180).first, coord(80,150).first, coord(80,90).first};
    cfg9.ASVs_goal = {coord(90,180).second, coord(90,150).second, coord(90,90).second};
    cfg9.ASVs_nominal_speed = {2.5, 2.5, 2.5};
    cfgs.push_back(cfg9);

    Config cfg10;
    cfg10.scenario = 10;
    cfg10.ASVs_eta0 = {coord(80,180).first, coord(80,-165).first, coord(80,90).first};
    cfg10.ASVs_goal = {coord(90,180).second, coord(90,-165).second, coord(90,90).second};
    cfg10.ASVs_nominal_speed = {2.5, 2.5, 2.5};
    cfgs.push_back(cfg10);

    Config cfg11;
    cfg11.scenario = 11;
    cfg11.ASVs_eta0 = {coord(80,180).first, coord(80,-90).first, coord(80,150).first};
    cfg11.ASVs_goal = {coord(90,180).second, coord(90,-90).second, coord(90,150).second};
    cfg11.ASVs_nominal_speed = {2.5, 2.5, 2.5};
    cfgs.push_back(cfg11);

    Config cfg12;
    cfg12.scenario = 12;
    cfg12.ASVs_eta0 = {coord(80,180).first, coord(80,0).first, coord(80,135).first, coord(80,-170).first};
    cfg12.ASVs_goal = {coord(90,180).second, coord(90,0).second, coord(90,135).second, coord(90,-170).second};
    cfg12.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg12);

    Config cfg13;
    cfg13.scenario = 13;
    cfg13.ASVs_eta0 = {coord(80,180).first, coord(80,0).first, coord(80,-135).first, coord(80,-170).first};
    cfg13.ASVs_goal = {coord(90,180).second, coord(90,0).second, coord(90,-135).second, coord(90,-170).second};
    cfg13.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg13);

    Config cfg14;
    cfg14.scenario = 14;
    cfg14.ASVs_eta0 = {coord(80,180).first, coord(80,170).first, coord(80,135).first, coord(80,90).first};
    cfg14.ASVs_goal = {coord(90,180).second, coord(90,170).second, coord(80,135).second, coord(80,90).second};
    cfg14.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg14);

    Config cfg15;
    cfg15.scenario = 15;
    cfg15.ASVs_eta0 = {coord(80,180).first, coord(45,180).first, coord(80,135).first, coord(80,90).first};
    cfg15.ASVs_goal = {coord(90,180).second, coord(45,180).second, coord(90,135).second, coord(90,90).second};
    cfg15.ASVs_nominal_speed = {2.5, 1, 2.5, 2.5};
    cfg15.activate_COLAV[1] = false;
    cfgs.push_back(cfg15);

    Config cfg16;
    cfg16.scenario = 16;
    cfg16.ASVs_eta0 = {coord(80,180).first, coord(80,-135).first, coord(80,-90).first, coord(80,90).first};
    cfg16.ASVs_goal = {coord(90,180).second, coord(90,-135).second, coord(90,-90).second, coord(90,90).second};
    cfg16.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg16);

    Config cfg17;
    cfg17.scenario = 17;
    cfg17.ASVs_eta0 = {coord(80,180).first, coord(45,180).first, coord(80,-170).first, coord(80,135).first};
    cfg17.ASVs_goal = {coord(80,180).second, coord(45,180).second, coord(80,-170).second, coord(80,135).second};
    cfg17.ASVs_nominal_speed = {2.5, 1, 2.5, 2.5};
    cfg17.activate_COLAV[1] = false;
    cfgs.push_back(cfg17);

    Config cfg18;
    cfg18.scenario = 18;
    cfg18.ASVs_eta0 = {coord(80,180).first, coord(80,165).first, coord(80,150).first, coord(80,45).first};
    cfg18.ASVs_goal = {coord(90,180).second, coord(90,165).second, coord(90,150).second, coord(90,45).second};
    cfg18.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg18);

    Config cfg19;
    cfg19.scenario = 19;
    cfg19.ASVs_eta0 = {coord(80,180).first, coord(80,-165).first, coord(80,165).first, coord(80,45).first};
    cfg19.ASVs_goal = {coord(90,180).second, coord(90,-165).second, coord(90,165).second, coord(90,45).second};
    cfg19.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg19);

    Config cfg20;
    cfg20.scenario = 20;
    cfg20.ASVs_eta0 = {coord(80,180).first, coord(45,180).first, coord(80,165).first, coord(80,90).first};
    cfg20.ASVs_goal = {coord(90,180).second, coord(45,180).second, coord(90,165).second, coord(90,90).second};
    cfg20.ASVs_nominal_speed = {2.5, 1, 2.5, 2.5};
    cfg20.activate_COLAV[1] = false;
    cfgs.push_back(cfg20);

    Config cfg21;
    cfg21.scenario = 21;
    cfg21.ASVs_eta0 = {coord(80,180).first, coord(80,-165).first, coord(80,165).first, coord(80,90).first};
    cfg21.ASVs_goal = {coord(90,180).second, coord(90,-165).second, coord(90,165).second, coord(90,90).second};
    cfg21.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg21);

    Config cfg22;
    cfg22.scenario = 22;
    cfg22.ASVs_eta0 = {coord(80,180).first, coord(45,180).first, coord(80,150).first, coord(80,90).first};
    cfg22.ASVs_goal = {coord(90,180).second, coord(45,180).second, coord(90,150).second, coord(90,90).second};
    cfg22.ASVs_nominal_speed = {2.5, 1, 2.5, 2.5};
    cfg22.activate_COLAV[1] = false;
    cfgs.push_back(cfg22);

    // extra test
    Config cfg23;
    cfg23.scenario = 23;
    cfg23.ASVs_eta0 = {coord(80,180).first, coord(80,-165).first, coord(80,165).first, coord(80,90).first, coord(80,-45).first};
    cfg23.ASVs_goal = {coord(90,180).second, coord(90,-165).second, coord(90,165).second, coord(90,90).second, coord(90,-45).second};
    cfg23.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg23);

    Config cfg24;
    cfg24.scenario = 24;
    cfg24.ASVs_eta0 = {coord(80,180).first, coord(80,0).first, coord(80,90).first, coord(80,-90).first, coord(80, -165).first};
    cfg24.ASVs_goal = {coord(90,180).second, coord(90,0).second, coord(90,90).second, coord(90,-90).second, coord(90,-165).second};
    cfg24.ASVs_nominal_speed = {2.5, 2.5, 2.5, 2.5, 2.5};
    cfgs.push_back(cfg24);

    if (1)
    {
        for (int i = 0; i < cfgs.size(); ++i)
        {
            std::cout << "start scenario " + std::to_string(i+1) + "!" << std::endl;
            run_simulation(empty_map, cfgs[i].ASVs_eta0, cfgs[i].ASVs_goal, cfgs[i].ASVs_nominal_speed, cfgs[i].activate_COLAV, cfgs[i].plot_opt, cfgs[i].scenario);
        }
    }
    else
    {
        auto cfg_test = cfg13;
        run_simulation(empty_map, cfg_test.ASVs_eta0, cfg_test.ASVs_goal, cfg_test.ASVs_nominal_speed, cfg_test.activate_COLAV, cfg_test.plot_opt, cfg_test.scenario);
    }

    show();
}