#ifndef COLREGS_H_
#define COLREGS_H_

#include "Pose_SE2.hpp"
#include "g2o_types/Edge_Colregs.hpp"

using namespace teb_local_planner;

class COLREGs
{
public:
    double t_low;
    double t_high;
    double t_hysteresis;

    double d;
    double d_hysteresis;

    double d_range;
    double d_close;

    double epsilon;

    std::vector<std::string> encounter_types;
    std::vector<std::pair<PoseSE2,Eigen::Vector3d>> motion_data;
    PoseSE2 eta;
    Eigen::Vector3d nu;
    Eigen::Vector2d p;
    Eigen::Vector2d v;

    COLREGs(std::vector<std::pair<PoseSE2,Eigen::Vector3d>>& ship_motion_data, int& ownship_index);
    void updateState(bool& safe);
    void updateEncounterType();
    std::pair<bool,RotType> getAction();
    int findSector(double& angle, double rotation);
public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW
};
#endif