#ifndef MOTION_PREDICTION_H_
#define MOTION_PREDICTION_H_

#include "Pose_SE2.hpp"

using namespace teb_local_planner;

class MotionPrediction
{
public:
    double timeStep;
    int ownship_idx;
    double prediction_horizon;
    double d_range;
    Eigen::Vector2d p;
    std::vector<std::pair<PoseSE2,Eigen::Vector3d>> motion_data;

    MotionPrediction(std::vector<std::pair<PoseSE2,Eigen::Vector3d>>& ship_motion_data, int& ownship_index);

    void straightLineMotion(std::pair<PoseSE2,Eigen::Vector3d>& ship_motion);

    void circularMotion(std::pair<PoseSE2,Eigen::Vector3d>& ship_motion);

    std::vector<Eigen::Vector2d> predict();

public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW
};

#endif