#include "../include/Motion_Prediction.hpp"

int main()
{
    std::vector<std::pair<PoseSE2,Eigen::Vector3d>> ship_motion_data;
    auto point1 = std::make_pair(PoseSE2(0,0,0),Eigen::Vector3d(1,1,-M_PI/8));
    auto point2 = std::make_pair(PoseSE2(10,10,M_PI),Eigen::Vector3d(1,1,0));
    auto point3 = std::make_pair(PoseSE2(20,20,M_PI/4),Eigen::Vector3d(1,1,0));
    ship_motion_data.push_back(point1);
    ship_motion_data.push_back(point2);
    ship_motion_data.push_back(point3);

    MotionPrediction motionPredictor(ship_motion_data,1);
    std::vector<Eigen::Vector2d> prediction = motionPredictor.predict(1);

    for (int i=0; i < prediction.size(); ++i)
    {
        std::cout << "positions \n" << i << ": " << prediction[i].transpose() << std::endl;
    }
}